mod Ex12 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  12. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 5.5.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane vyrokovej logike. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex12*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Propositional Logic.  \end 

rem 
  \para \bf  Arithmetization of propositional formulas.  \end 

fun/0 Tc 'Tex_f0_pl_tc'
  Tc = 0,0

fun/0 Fc 'Tex_f0_pl_fc'
  Fc = 1,0

fun Pvar 'Tex_f1_pl_pvar'
  Pvar(i) = 2,i

fun Not 'Tex_f1_pl_not'
  Not(a) = 3,a

fun/2 And 'Tex_f2_pl_and'
  And(a,b) = 4,a,b

fun/2 Or 'Tex_f2_pl_or'
  Or(a,b) = 5,a,b

fun/2 Imp 'Tex_f2_pl_imp'
  Imp(a,b) = 6,a,b

fun/2 Iff 'Tex_f2_pl_iff'
  Iff(a,b) = 7,a,b

pred Form 
  Form(Tc)
  Form(Fc)
  Form Pvar(i) <- N(i)
  Form Not(a) <- Form(a)
  Form And(a,b) <- Form(a) & Form(b)
  Form Or(a,b) <- Form(a) & Form(b)
  Form Imp(a,b) <- Form(a) & Form(b)
  Form Iff(a,b) <- Form(a) & Form(b)

pred Lform 
  Lform(0)
  Lform(a,as) <- Form(a) & Lform(as)

rem 
  \para \bf  Justification of case analysis on propositional formulas.  \end 
  Prove 

thm Case_analysis_on_propositional_formulas
  Form(a) -> 
  a = Tc \/ a = Fc \/ \e i(a = Pvar(i) & N(i)) \/ \e b a = Not(b) \/ 
  \e b\e c a = And(b,c) \/ \e b\e c a = Or(b,c) \/ \e b\e c a = Imp(b,c) \/ 
  \e b\e c a = Iff(b,c)

rem 
  \para \bf  [CL] Case analysis on propositional_formulas.  \end Syntax: 
  \items 
   \item \para the command \it  case  \end \ft Form \end \it  ;  \end 
         \ft Tex0_tau \end invokes case analysis on the propositional_formula 
         \ft Tex0_tau \end. 
  \end
  \para See also the theorem \it  Case_analysis_on_propositional_formulas  \end. 

rem 
  \para \bf  Justification of structural induction on propositional formulas. 
   \end Demonstrate the admissibility of structural induction on propositional 
  formulas. 

theory Admissibility_of_structural_induction_on_propositional_formulas

pred A 'Tex_p1_phi_subst'

axiom Assumption_tc
  A(Tc)

axiom Assumption_fc
  A(Fc)

axiom Assumption_pvar
  N(i) -> A Pvar(i)

axiom Assumption_not
  A(a) -> A Not(a)

axiom Assumption_and
  A(a) & A(b) -> A And(a,b)

axiom Assumption_or
  A(a) & A(b) -> A Or(a,b)

axiom Assumption_imp
  A(a) & A(b) -> A Imp(a,b)

axiom Assumption_iff
  A(a) & A(b) -> A Iff(a,b)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Form(a) -> A(a)
  \end
  \para \it  [CL] Hint.  \end Prove the claim by induction with measure 
  \ft |a| \end. 

thm Conclusion
  Form(a) -> A(a)

end theory Admissibility_of_structural_induction_on_propositional_formulas

theory Admissibility_of_structural_induction_on_propositional_formulas_strong_form

pred A 'Tex_p1_phi_subst'

axiom Assumption_tc
  A(Tc)

axiom Assumption_fc
  A(Fc)

axiom Assumption_pvar
  N(i) -> A Pvar(i)

axiom Assumption_not
  Form(a) & A(a) -> A Not(a)

axiom Assumption_and
  Form(a) & A(a) & Form(b) & A(b) -> A And(a,b)

axiom Assumption_or
  Form(a) & A(a) & Form(b) & A(b) -> A Or(a,b)

axiom Assumption_imp
  Form(a) & A(a) & Form(b) & A(b) -> A Imp(a,b)

axiom Assumption_iff
  Form(a) & A(a) & Form(b) & A(b) -> A Iff(a,b)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Form(a) -> A(a)
  \end
  \para \it  [CL] Hint.  \end Prove the claim by induction with measure 
  \ft |a| \end. 

thm Conclusion
  Form(a) -> A(a)

end theory Admissibility_of_structural_induction_on_propositional_formulas_strong_form

rem 
  \para \bf  [CL] Structural induction on propositional formulas.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft Form \end \it  ;  \end \ft a \end 
         invokes structural induction on the propositional formula \ft a \end 
         with the induction formula \ft Tex2_bappl1(Tex0_phi,a) \end, where 
         \ft Tex2_bappl1(Tex0_phi,a) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft Form \end \it  ;  \end \ft a \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         propositional formula \ft a \end with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,a,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,t,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Form \end \it  ;  \end \ft a \end 
         invokes structural induction on the propositional formula \ft a \end 
         (strong form) with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,a) \end, where 
         \ft Tex2_bappl1(Tex0_phi,a) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Form \end \it  ;  \end \ft a \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         propositional formula \ft a \end (strong form) with the induction 
         formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,a,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,a,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Propositional size.  \end 

fun Sz 'Tex_f1_pl_sz'
  Sz(a) = Foo

fun Szl 'Tex_f1_pl_szl'
  Szl(as) = Foo

rem 
  \para \bf  Propositional variables.  \end 

pred Lpvar 
  Lpvar(as) <-> Poo

fun Pv 'Tex_f1_pl_pv'
  Pv(a) = Foo

fun Pvl 'Tex_f1_pl_pvl'
  Pvl(as) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Lpvar_zero
    Lpvar(0)
  \end
  \eq Lpvar_pair
    Lpvar(a,as) <-> \e i a = Pvar(i) & Lpvar(as)
  \end

thm Lpvar_zero
  Lpvar(0)

thm Lpvar_pair
  Lpvar(a,as) <-> \e i a = Pvar(i) & Lpvar(as)

rem 
  \para \bf  Truth predicate.  \end 

pred/2 True 'Tex_p2_pl_true'
  True(v,a) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq True_tc
    True(v,Tc)
  \end
  \eq True_fc
    ~True(v,Fc)
  \end
  \eq True_pvar
    True(v,Pvar(i)) <-> i in v
  \end
  \eq True_not
    True(v,Not(a)) <-> ~True(v,a)
  \end
  \eq True_and
    True(v,And(a,b)) <-> True(v,a) & True(v,b)
  \end
  \eq True_or
    True(v,Or(a,b)) <-> True(v,a) \/ True(v,b)
  \end
  \eq True_imp
    True(v,Imp(a,b)) <-> True(v,a) -> True(v,b)
  \end
  \eq True_iff
    True(v,Iff(a,b)) <-> True(v,a) <-> True(v,b)
  \end

thm True_tc
  True(v,Tc)

thm True_fc
  ~True(v,Fc)

thm True_pvar
  True(v,Pvar(i)) <-> i in v

thm True_not
  True(v,Not(a)) <-> ~True(v,a)

thm True_and
  True(v,And(a,b)) <-> True(v,a) & True(v,b)

thm True_or
  True(v,Or(a,b)) <-> True(v,a) \/ True(v,b)

thm True_imp
  True(v,Imp(a,b)) <-> True(v,a) -> True(v,b)

thm True_iff
  True(v,Iff(a,b)) <-> True(v,a) <-> True(v,b)

rem 
  \para \bf  Coincidence of propositional valuations.  \end 

pred/3 Equiv 'Tex_p3_pl_equiv'
  Equiv(v1,v2,is) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Equiv_true_form
    Form(a) & Equiv(v1,v2,Pv(a)) -> True(v1,a) <-> True(v2,a)
  \end

thm Equiv_true_form
  Form(a) & Equiv(v1,v2,Pv(a)) -> True(v1,a) <-> True(v2,a)

rem 
  \para \bf  Tautologies.  \end 

pred Taut 'Tex_p1_pl_taut'
  Taut(a) <-> Poo

rem 
  \para \bf  Generalized connectives.  \end 

fun Andl 'Tex_f1_pl_andl'
  Andl(as) = Foo

fun Orl 'Tex_f1_pl_orl'
  Orl(as) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Andl_form
    Lform(as) -> Form Andl(as)
  \end
  \eq True_andl_in
    True(v,Andl(as)) <-> \a a(a in as -> True(v,a))
  \end
  \eq True_andl_conc
    True(v,Andl(as++bs)) <-> True(v,Andl(as)) & True(v,Andl(bs))
  \end

thm Andl_form
  Lform(as) -> Form Andl(as)

thm True_andl_in
  True(v,Andl(as)) <-> \a a(a in as -> True(v,a))

thm True_andl_conc
  True(v,Andl(as++bs)) <-> True(v,Andl(as)) & True(v,Andl(bs))
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Orl_form
    Lform(as) -> Form Orl(as)
  \end
  \eq True_orl_in
    True(v,Orl(as)) <-> \e a(a in as & True(v,a))
  \end
  \eq True_orl_conc
    True(v,Orl(as++bs)) <-> True(v,Orl(as)) \/ True(v,Orl(bs))
  \end

thm Orl_form
  Lform(as) -> Form Orl(as)

thm True_orl_in
  True(v,Orl(as)) <-> \e a(a in as & True(v,a))

thm True_orl_conc
  True(v,Orl(as++bs)) <-> True(v,Orl(as)) \/ True(v,Orl(bs))
proof  proved.

rem 
  \para \bf  Propositional sequents.  \end 

pred/2 Tautsq 'Tex_p2_pl_tautsq'
  Tautsq(as,bs) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Taut_tautsq
    Taut(a) <-> Tautsq(0,a,0)
  \end
  \eq Tautsq_conc_a
    Tautsq(as1++(a,as2),bs) <-> Tautsq((a,as1++as2),bs)
  \end
  \eq Tautsq_conc_g
    Tautsq(as,bs1++(b,bs2)) <-> Tautsq(as,b,bs1++bs2)
  \end
  \eq Tautsq_tc_a
    Tautsq((Tc,as),bs) <-> Tautsq(as,bs)
  \end
  \eq Tautsq_tc_g
    Tautsq(as,Tc,bs)
  \end
  \eq Tautsq_fc_a
    Tautsq((Fc,as),bs)
  \end
  \eq Tautsq_fc_g
    Tautsq(as,Fc,bs) <-> Tautsq(as,bs)
  \end
  \eq Tautsq_pvar_ag
    Tautsq((Pvar(i),as),Pvar(i),bs)
  \end
  \eq Tautsq_not_a
    Tautsq((Not(a),as),bs) <-> Tautsq(as,a,bs)
  \end
  \eq Tautsq_not_g
    Tautsq(as,Not(a),bs) <-> Tautsq((a,as),bs)
  \end
  \eq Tautsq_and_a
    Tautsq((And(a,b),as),bs) <-> Tautsq((a,b,as),bs)
  \end
  \eq Tautsq_and_g
    Tautsq(as,And(a,b),bs) <-> Tautsq(as,a,bs) & Tautsq(as,b,bs)
  \end
  \eq Tautsq_or_a
    Tautsq((Or(a,b),as),bs) <-> Tautsq((a,as),bs) & Tautsq((b,as),bs)
  \end
  \eq Tautsq_or_g
    Tautsq(as,Or(a,b),bs) <-> Tautsq(as,a,b,bs)
  \end
  \eq Tautsq_imp_a
    Tautsq((Imp(a,b),as),bs) <-> Tautsq(as,a,bs) & Tautsq((b,as),bs)
  \end
  \eq Tautsq_imp_g
    Tautsq(as,Imp(a,b),bs) <-> Tautsq((a,as),b,bs)
  \end
  \eq Tautsq_iff_a
    Tautsq((Iff(a,b),as),bs) <-> Tautsq(as,a,b,bs) & Tautsq((a,b,as),bs)
  \end
  \eq Tautsq_iff_g
    Tautsq(as,Iff(a,b),bs) <-> Tautsq((a,as),b,bs) & Tautsq((b,as),a,bs)
  \end

thm Taut_tautsq
  Taut(a) <-> Tautsq(0,a,0)

thm Tautsq_conc_a
  Tautsq(as1++(a,as2),bs) <-> Tautsq((a,as1++as2),bs)

thm Tautsq_conc_g
  Tautsq(as,bs1++(b,bs2)) <-> Tautsq(as,b,bs1++bs2)

thm Tautsq_tc_a
  Tautsq((Tc,as),bs) <-> Tautsq(as,bs)

thm Tautsq_tc_g
  Tautsq(as,Tc,bs)

thm Tautsq_fc_a
  Tautsq((Fc,as),bs)

thm Tautsq_fc_g
  Tautsq(as,Fc,bs) <-> Tautsq(as,bs)

thm Tautsq_pvar_ag
  Tautsq((Pvar(i),as),Pvar(i),bs)

thm Tautsq_not_a
  Tautsq((Not(a),as),bs) <-> Tautsq(as,a,bs)

thm Tautsq_not_g
  Tautsq(as,Not(a),bs) <-> Tautsq((a,as),bs)

thm Tautsq_and_a
  Tautsq((And(a,b),as),bs) <-> Tautsq((a,b,as),bs)

thm Tautsq_and_g
  Tautsq(as,And(a,b),bs) <-> Tautsq(as,a,bs) & Tautsq(as,b,bs)

thm Tautsq_or_a
  Tautsq((Or(a,b),as),bs) <-> Tautsq((a,as),bs) & Tautsq((b,as),bs)

thm Tautsq_or_g
  Tautsq(as,Or(a,b),bs) <-> Tautsq(as,a,b,bs)

thm Tautsq_imp_a
  Tautsq((Imp(a,b),as),bs) <-> Tautsq(as,a,bs) & Tautsq((b,as),bs)

thm Tautsq_imp_g
  Tautsq(as,Imp(a,b),bs) <-> Tautsq((a,as),b,bs)

thm Tautsq_iff_a
  Tautsq((Iff(a,b),as),bs) <-> Tautsq(as,a,b,bs) & Tautsq((a,b,as),bs)

thm Tautsq_iff_g
  Tautsq(as,Iff(a,b),bs) <-> Tautsq((a,as),b,bs) & Tautsq((b,as),a,bs)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq True_pvl_pvar
    Lpvar(as) -> True(Pvl(as),Pvar(i)) <-> Pvar(i) in as
  \end
  \eq True_pvl_andl
    Lpvar(as) -> True(Pvl(as),Andl(as))
  \end
  \eq True_pvl_orl
    Lpvar(as) & Lpvar(bs) -> True(Pvl(as),Orl(bs)) <-> 
    \e i(Pvar(i) in as & Pvar(i) in bs)
  \end
  \eq Tautsq_lpvar
    Lpvar(as) & Lpvar(bs) -> Tautsq(as,bs) <-> 
    \e i(Pvar(i) in as & Pvar(i) in bs)
  \end

thm True_pvl_pvar
  Lpvar(as) -> True(Pvl(as),Pvar(i)) <-> Pvar(i) in as

thm True_pvl_andl
  Lpvar(as) -> True(Pvl(as),Andl(as))

thm True_pvl_orl
  Lpvar(as) & Lpvar(bs) -> True(Pvl(as),Orl(bs)) <-> 
  \e i(Pvar(i) in as & Pvar(i) in bs)

thm Tautsq_lpvar
  Lpvar(as) & Lpvar(bs) -> Tautsq(as,bs) <-> \e i(Pvar(i) in as & Pvar(i) in bs)

rem 
  \para \bf  Tautology checker for atomic propositional sequents.  \end 

pred/2 Closes 
  Closes(as,bs) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Lemma_spec_closes
    Closes(as,bs) <-> \e c(c in as & c in bs)
  \end
  \eq Spec_closes
    Lpvar(as) & Lpvar(bs) -> Closes(as,bs) <-> Tautsq(as,bs)
  \end

thm Lemma_spec_closes
  Closes(as,bs) <-> \e c(c in as & c in bs)

thm Spec_closes
  Lpvar(as) & Lpvar(bs) -> Closes(as,bs) <-> Tautsq(as,bs)

rem 
  \para \bf  Auxiliary predicate.  \end 

pred/4 Prfsq1 'Tex_p4_pl_prfsq1'
  Prfsq1(as,bs,cs,ds) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_prfsq1
    Lform(as) & Lpvar(bs) & Lform(cs) & Lpvar(ds) -> Prfsq1(as,bs,cs,ds) <-> 
    Tautsq(as++bs,cs++ds)
  \end

thm Spec_prfsq1
  Lform(as) & Lpvar(bs) & Lform(cs) & Lpvar(ds) -> Prfsq1(as,bs,cs,ds) <-> 
  Tautsq(as++bs,cs++ds)

rem 
  \para \bf  Tautology checker for propositional sequents.  \end 

pred/2 Prfsq 'Tex_p2_pl_prfsq'
  Prfsq(as,bs) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_prfsq
    Lform(as) & Lform(bs) -> Prfsq(as,bs) <-> Tautsq(as,bs)
  \end

thm Spec_prfsq
  Lform(as) & Lform(bs) -> Prfsq(as,bs) <-> Tautsq(as,bs)

rem 
  \para \bf  Tautology checker.  \end 

pred Prf 'Tex_p1_pl_prf'
  Prf(a) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_prf
    Form(a) -> Prf(a) <-> Taut(a)
  \end

thm Spec_prf
  Form(a) -> Prf(a) <-> Taut(a)

